SHELL:=/usr/bin/env bash
export LC_ALL=C
export LANG=C
-export TOPDIR=${shell pwd}
-include $(TOPDIR)/include/verbose.mk
+export TOPDIR=${CURDIR}
ifeq ($(KBUILD_VERBOSE),99)
MAKE:=3>/dev/null $(MAKE)
endif
+export IS_TTY=$(shell tty -s && echo 1 || echo 0)
+
+include $(TOPDIR)/include/verbose.mk
OPENWRTVERSION:=$(RELEASE)
ifneq ($(VERSION),)
endif
export OPENWRTVERSION
-ifneq ($(shell ./scripts/timestamp.pl -p tmp/.pkginfo package scripts Makefile),tmp/.pkginfo)
- tmp/.pkginfo: tmpinfo-clean
+ifneq ($(shell ./scripts/timestamp.pl -p tmp/.pkginfo package scripts include),tmp/.pkginfo)
+ tmp/.pkginfo: FORCE
endif
-ifneq ($(shell ./scripts/timestamp.pl -p tmp/.targetinfo target/linux scripts Makefile),tmp/.targetinfo)
- tmp/.targetinfo: tmpinfo-clean
+ifneq ($(shell ./scripts/timestamp.pl -p tmp/.targetinfo target/linux scripts include),tmp/.targetinfo)
+ tmp/.targetinfo: FORCE
endif
ifeq ($(FORCE),)
.config scripts/config/conf scripts/config/mconf: tmp/.prereq-build
- world: tmp/.prereq-packages
+ world: tmp/.prereq-packages tmp/.prereq-target
endif
-tmp/.pkginfo:
+ifeq ($(IS_TTY),1)
+ define progress
+ printf "\033[M\r$(1)" >&2;
+ endef
+endif
+
+define dumpinfo
@mkdir -p tmp
- @echo Collecting package info...
- @-for dir in package/*/; do \
+ @echo -n Collecting $(2) info...
+ @-for dir in $(1)/*/; do \
[ -f "$${dir}/Makefile" ] || continue; \
+ $(call progress,Collecting $(2) info: $${dir%%/}) \
echo Source-Makefile: $${dir}Makefile; \
$(NO_TRACE_MAKE) --no-print-dir DUMP=1 -C $$dir 3>/dev/null || echo "ERROR: please fix $${dir}Makefile" >&2; \
echo; \
done > $@
+ @($(call progress,Collecting $(2) info: done))
+ @echo
+endef
+
+tmp/.pkginfo:
+ $(call dumpinfo,package,package)
tmp/.targetinfo:
- @mkdir -p tmp
- @echo Collecting target info...
- @-for dir in target/linux/*/; do \
- [ -f "$${dir}/Makefile" ] || continue; \
- ( cd "$$dir"; $(NO_TRACE_MAKE) --no-print-dir DUMP=1 3>/dev/null || echo "ERROR: please fix $${dir}Makefile" >&2 ); \
- echo; \
- done > $@
+ $(call dumpinfo,target/linux,target)
tmpinfo-clean: FORCE
@-rm -rf tmp/.pkginfo tmp/.targetinfo
tmp/.config.in: tmp/.pkginfo
- @./scripts/gen_package_config.pl < $< > $@ || rm -f $@
+ @./scripts/metadata.pl package_config < $< > $@ || rm -f $@
tmp/.config-target.in: tmp/.targetinfo
- @./scripts/gen_target_config.pl < $< > $@ || rm -f $@
+ @./scripts/metadata.pl target_config < $< > $@ || rm -f $@
.config: ./scripts/config/conf tmp/.config.in tmp/.config-target.in
@[ -f .config ] || $(NO_TRACE_MAKE) menuconfig
tmp/.prereq-build: include/prereq-build.mk
@mkdir -p tmp
+ @rm -f tmp/.host.mk
@$(NO_TRACE_MAKE) -s -f $(TOPDIR)/include/prereq-build.mk prereq 2>/dev/null || { \
echo "Prerequisite check failed. Use FORCE=1 to override."; \
false; \
tmp/.prereq-packages: include/prereq.mk tmp/.pkginfo .config
@mkdir -p tmp
+ @rm -f tmp/.host.mk
@$(NO_TRACE_MAKE) -s -C package prereq 2>/dev/null || { \
echo "Prerequisite check failed. Use FORCE=1 to override."; \
false; \
}
@touch $@
-
-prereq: tmp/.prereq-build tmp/.prereq-packages FORCE
+
+tmp/.prereq-target: include/prereq.mk tmp/.targetinfo .config
+ @mkdir -p tmp
+ @rm -f tmp/.host.mk
+ @$(NO_TRACE_MAKE) -s -C target prereq 2>/dev/null || { \
+ echo "Prerequisite check failed. Use FORCE=1 to override."; \
+ false; \
+ }
+ @touch $@
+
+prereq: tmp/.prereq-build tmp/.prereq-packages tmp/.prereq-target FORCE
download: .config FORCE
$(MAKE) tools/download
distclean: dirclean config-clean
rm -rf dl
+help:
+ cat README
+
+doc:
+ $(MAKE) -C docs/ openwrt.pdf
+
+docclean:
+ $(MAKE) -C docs/ clean
+
.SILENT: clean dirclean distclean config-clean download world
FORCE: ;
-.PHONY: FORCE
+.PHONY: FORCE help
%: ;